#include <stdio.h>
#include <alloc.h>
#include <conio.h>
#include <process.h>
#include "janela.h"

janela salve_janela (int x1, int y1, int x2, int y2, janela j)

  {

    struct janela *proxima; /* Ponteiro para a prxima janela. */
    proxima = malloc (sizeof (struct janela));
    proxima->pendente = (unsigned int *) malloc ((x2-x1+1)*(y2-y1+1)*2);
    if (!gettext (x1,y1,x2,y2,proxima->pendente)) {
      clrscr ();
      cprintf ("Erro: Nao consegui ler caracteres da tela.");
      exit (0);
    }
    /* Coloca a struct janela preenchida na pilha de janelas, fazendo    */
    /* com que ela aponte para a ultima janela existente.                */

    proxima->prox = j;

    /* Salvar na struct janela as coordenadas da mesma.*/
    proxima->c1 = x1;
    proxima->l1 = y1;
    proxima->c2 = x2;
    proxima->l2 = y2;

    proxima->frente = WHITE;
    proxima->fundo = BLACK;

    proxima->moldura =0;

    proxima->x=wherex ();
    proxima->y=wherey ();


    window (x1, y1, x2, y2);

    /* Atualiza ponteiro */
    return proxima;

  }


janela feche_janela (janela j)

  {

      struct janela *aux;       /* Ponteiro auxiliar para a janela.  */
      int lin, col;

     col=j->x;
     lin=j->y;

    /* Preenche o que foi encoberto pela janela.                              */

      puttext (j->c1,j->l1,j->c2,j->l2,j->pendente);

    /* Aux salva a futura ponta da pilha de janela,ou seja a penultima janela*/

      aux = j->prox;

    /* Libera a cadeia de caracteres da janela.                              */

      free (j->pendente);

    /* Libera a struct janela.                                               */

      free (j);

      if (aux==NULL) {
	textcolor (WHITE);
	textbackground (BLACK);
	window (1, 1, 80, 25);
	gotoxy (col, lin);
      }
      else {
	textcolor (aux->frente);
	textbackground (aux->fundo);
	if (aux->moldura == 0)
	  window (aux->c1, aux->l1, aux->c2, aux->l2);
	else
	  window (aux->c1+1, aux->l1+1, aux->c2-1, aux->l2-1);
	gotoxy (col, lin);
      }

    /* Retorne a ponta atual da pilha. (antiga penultima janela.)            */

      return (aux);

  }

janela mova_janela (int direcao, int limite, janela j)

  {
     struct janela *aux=NULL;

     if ((direcao > 0) && (direcao < 5)) /* A direcao e valida */
       { /* Salva a janela que sera movimentada.*/
	 aux = salve_janela (j->c1, j->l1, j->c2, j->l2, aux);
	 /* escolha a direcao desejada. */
	 switch (direcao)
	   {
	     case 1:                 /* A janela deve subir */
	       if (aux->l1>limite) /* Ela pode subir? */
		 {
		   aux->l1--;        /* se sim atualize inices de linhas.*/
		   aux->l2--;
           gotoxy (wherex (), wherey ()-1);
         }
	       break;
	     case 2:                 /* A janela deve ir para a direita */
	       if (aux->l2<limite) /* Ela pode ir para a direita? */
		 {
		   aux->l1++;        /* Se sim atualize indices de colunas.*/
		   aux->l2++;
           gotoxy (wherex ()+1, wherey ());
		 }
	       break;
	     case 3:                 /* A janela deve ir para baixo.*/
	       if (aux->c2<limite) /* Ela pode ir para baixo?*/
		 {
		   aux->c1++;        /* Se sim atualize indices de linhas.*/
		   aux->c2++;
           gotoxy (wherex (), wherey ()+1);
		 }
	       break;
	     case 4:                 /* A janela deve ir para a esquerda.*/
	       if (aux->c1>limite) /* Ela pode ir para a esquerda?*/
		 {
		   aux->c1--;        /* Se sim atualize indices de colunas.*/
		   aux->c2--;
           gotoxy (wherex ()-1, wherey ());
		 }
	       break;
	   }
	 /* Feche a janela que ira se mover.*/
	 j = feche_janela (j);
	 /* Salve oque sera sobreposto pela janela na nova posicao.*/
	 j = salve_janela (aux->c1, aux->l1, aux->c2, aux->l2, j);
	 /* Coloque-a na nova posicao.*/
	 aux = feche_janela (aux);
       }
     if (aux->moldura == 0)
       window (aux->c1, aux->l1, aux->c2, aux->l2);
     else
       window (aux->c1+1, aux->l1+1, aux->c2-1, aux->l2-1);
     /* Retorne o apontador para a janela.*/
     return (j);
  }


void moldura (int x1, int y1, int x2, int y2, janela j,
	      int tipo, int fundo, int frente)

  {
     int contador;

     j->fundo = fundo;
     j->frente = frente;
     j->moldura = tipo;
     window (x1, y1, x2, y2);
     textbackground (fundo);
     textcolor (frente);
     clrscr ();
     window (1, 1, 80, 25);
     gotoxy (x1, y1);
     switch (tipo)       /* Escolha caracter superior esquerdo.*/
     {
      case 0: break;
      case 1: { cprintf ("%c",201); break; }
      case 2: { cprintf ("%c",177); break; }
      case 3: { cprintf ("%c",214); break; }
      case 4: { cprintf ("%c",213); break; }
      case 5: { cprintf ("%c",176); break; }
      case 6: { cprintf ("%c",042); break; }
      case 7: { cprintf ("%c",178); break; }
      case 8: { cprintf ("%c",219); break; }
     }
     gotoxy (x2, y1);    /* Escolha caracter superior direito.*/
     switch (tipo)
     {
      case 0: break;
      case 1: { cprintf ("%c",187); break; }
      case 2: { cprintf ("%c",177); break; }
      case 3: { cprintf ("%c",183); break; }
      case 4: { cprintf ("%c",184); break; }
      case 5: { cprintf ("%c",176); break; }
      case 6: { cprintf ("%c",042); break; }
      case 7: { cprintf ("%c",178); break; }
      case 8: { cprintf ("%c",219); break; }
     }
     gotoxy (x1,y2);    /* Escolha caracter inferior esquerdo.*/
     switch (tipo)
     {
      case 0: break;
      case 1: { cprintf ("%c",200); break; }
      case 2: { cprintf ("%c",177); break; }
      case 3: { cprintf ("%c",211); break; }
      case 4: { cprintf ("%c",212); break; }
      case 5: { cprintf ("%c",176); break; }
      case 6: { cprintf ("%c",042); break; }
      case 7: { cprintf ("%c",178); break; }
      case 8: { cprintf ("%c",219); break; }
     }
     gotoxy (x2, y2);   /* Escolha caracter inferior direito.*/
     switch (tipo)
     {
      case 0: break;
      case 1: { cprintf ("%c",188); break; }
      case 2: { cprintf ("%c",177); break; }
      case 3: { cprintf ("%c",189); break; }
      case 4: { cprintf ("%c",190); break; }
      case 5: { cprintf ("%c",176); break; }
      case 6: { cprintf ("%c",042); break; }
      case 7: { cprintf ("%c",178); break; }
      case 8: { cprintf ("%c",219); break; }
     }
     for (contador=(y1+1); contador<y2; contador++) {
       gotoxy (x1, contador); /* Linha superior. */
       switch (tipo)
       {
	 case 0: break;
	 case 1: { cprintf ("%c",186); break; }
	 case 2: { cprintf ("%c",177); break; }
	 case 3: { cprintf ("%c",186); break; }
	 case 4: { cprintf ("%c",179); break; }
	 case 5: { cprintf ("%c",176); break; }
	 case 6: { cprintf ("%c",042); break; }
	 case 7: { cprintf ("%c",178); break; }
	 case 8: { cprintf ("%c",219); break; }
       }
       gotoxy (x2, contador);  /* Linha inferior. */
       switch (tipo)
       {
	 case 0: break;
	 case 1: { cprintf ("%c",186); break; }
	 case 2: { cprintf ("%c",177); break; }
	 case 3: { cprintf ("%c",186); break; }
	 case 4: { cprintf ("%c",179); break; }
	 case 5: { cprintf ("%c",176); break; }
	 case 6: { cprintf ("%c",042); break; }
	 case 7: { cprintf ("%c",178); break; }
	 case 8: { cprintf ("%c",219); break; }
       }
      }
      for (contador=(x1+1); contador<x2; contador++) {
	gotoxy  (contador, y1);  /* Linha esquerda. */
	switch (tipo)
	{
	  case 0: break;
	  case 1: { cprintf ("%c",205); break; }
	  case 2: { cprintf ("%c",177); break; }
	  case 3: { cprintf ("%c",196); break; }
	  case 4: { cprintf ("%c",205); break; }
	  case 5: { cprintf ("%c",176); break; }
	  case 6: { cprintf ("%c",042); break; }
	  case 7: { cprintf ("%c",178); break; }
	  case 8: { cprintf ("%c",219); break; }
	}
	gotoxy (contador, y2);  /* Linha direita. */
	switch (tipo)
	{
	  case 0: break;
	  case 1: { cprintf ("%c",205); break; }
	  case 2: { cprintf ("%c",177); break; }
	  case 3: { cprintf ("%c",196); break; }
	  case 4: { cprintf ("%c",205); break; }
	  case 5: { cprintf ("%c",176); break; }
	  case 6: { cprintf ("%c",042); break; }
	  case 7: { cprintf ("%c",178); break; }
	  case 8: { cprintf ("%c",219); break; }
	}
     }
     if (tipo == 0)
       window (x1, y1, x2, y2);
     else
       window (x1+1, y1+1, x2-1, y2-1);
     gotoxy (1, 1);
  }
