/* Input.c */

#include <conio.h>
#include <ctype.h>
#include "input.h"
#include "janela.h"

int in_char (char *string, int fundo, int frente)
{
  int posit=1, /* Posicao que esta sendo editada */
      max,     /* Numero maximo de caracteres */
      x, y,    /* Posicao atual do cursor */
      cont;

  x=wherex ();
  y=wherey ();

  max = 1 + (int) string [0];

  if (fundo != SEMCOR || frente != SEMCOR) {
    textcolor (BLACK);
    textbackground (WHITE);
  }

  for (cont=1; cont<max; cont++)
    cprintf (" ");
  gotoxy (x, y);

  while (1) {
    char keyboard;

    do keyboard=getch (); while (!isprint (keyboard) &&
				 keyboard != RETURN  &&
				 keyboard != BACKSPACE);
    if (keyboard == RETURN) {
      string [++posit]='\0';
      break;
    }
    else
      if (keyboard == BACKSPACE) {
	if (posit > 1) {
	  cprintf ("\b \b");
	  posit--;
	}
      }
      else
	if (posit < max)
	  putch (string [++posit]=keyboard);
	else
	  putch (BELL);
  }
  string [1]= (char) posit - 2;
  if (fundo != SEMCOR || frente != SEMCOR) {
    textcolor (frente);
    textbackground (fundo);
  }
  gotoxy (x, y);

  for (cont=1; cont<max; cont++)
    if (cont < posit-1)
      cprintf ("%c", string [cont+1]);
    else
      cprintf (" ");

  gotoxy (x, y);
}

