/* ----------- keyboard.c ---------- */

#include <bios.h>
#include <dos.h>
#include "keys.h"

/*
 * Read a keystroke
 */
int getkey(void)
{
	int c;

	while (bioskey(1) == 0)
		geninterrupt(0x28);
	if (((c = bioskey(0)) & 0xFF) == 0)
		c = (c >> 8) | 0x80;
	return c & 0xFF;
}
