/* -------- modem.h ------------
 * Modem Definitions
 */
/* -------- Hayes modem control strings --------- */
#define RESET_MODEM "ATZ\r~"
#define INIT_MODEM  "AT&C1E0M1S7=60S11=55V1X3S0=0\r~"
#define HANG_UP     "~+++~ATH0\r~ATS0=0\r~"
#define ANSWER      "ATS0=1\r"
#define TRANSF_RATE 9600
#define SUCCESS        1
#define FAILURE        0

/* --------- prototypes ---------- */
void initialize_modem(void);
int call_remote(char *);
void answer_modem(void);
void hang_up(void);
void release_modem(void);
